//////////////////////////////////////////////////////////////////////////
//
//	Vital Systems Inc. Copyright (c) 2003 - All Rights Reserved.
//  IDE : Visual Studio C++ 6.0 SP5
//
//	Description: Windows driver interface for PCI7202B CAN adapters.
//
//  Revision History :
//  Version		Date		Developer	
//	1.0			5/2/01		AR
//	2.0			4/22/03		AR
//
//////////////////////////////////////////////////////////////////////////

#ifndef PCICANDRV1_DRIVER_H_
#define PCICANDRV1_DRIVER_H_


class CPCINet : public CCANet
{

public:
	// Channel number 0,1,2 ....
	CPCINet( int nChannel );
	virtual ~CPCINet();

	// Rcv CAN message from driver internal queue (NonBlocking Call)
	BOOL GetMsg( ULONG& Identifier, UCHAR* Msg, UCHAR& MsgSize );

	// Send CAN Bus Message
	BOOL SendMsg( ULONG Identifier, UCHAR* Msg, UCHAR MsgSize );

	// Empty RCV Que for this channel. Rcv Queue size is 200 messeges
	BOOL ResetMsgQue();

	// Control the LEDs on bracket. 1 tick = 10mSec
	void BlinkCommsLED( UCHAR ticks );
	void BlinkErrorLED( UCHAR ticks );

	// Get number of boards installed
	BOOL GetBoardCount( UCHAR &Count );

	// Set CAN parameter for 16 Mhz crystal.

	// BusSpeed	125 kbps	250 kbps	500 Kbps	1 Mbps
	// BTR0		3			1			0			0
	// BTR1		0x1C		0x1C		0x1C		0x14

	BOOL SetBusParam( UCHAR BTr0, UCHAR BTr1,
					  UCHAR ACr0, UCHAR ACr1,
					  UCHAR ACr2, UCHAR ACr3,
					  UCHAR AMr0, UCHAR AMr1,
					  UCHAR AMr2, UCHAR AMr3 );

	BOOL SetBusParam( UCHAR BTr0, UCHAR BTr1, 
					  ULONG Ident1, ULONG Mask1,
					  ULONG Ident2, ULONG Mask2 );

	// Get error counters
	BOOL GetErrorCounters( UINT &NetError, UINT &TxOverRuns, UINT &RxOverRuns );

	// reset error counter
	BOOL ResetErrorCounters();

	BOOL DisableCAN();

private:
	//Converts linear channel number to absolute value
	BOOL GetAbsChannel( UCHAR Channel, UCHAR &AbsChannel );
};


#endif